\documentclass[a4paper,12pt]{article}
\usepackage[a4paper]{geometry}
\usepackage{fancyhdr,amsmath,amssymb}
\usepackage{graphicx,subfig,tikz}
\usetikzlibrary{positioning,decorations.pathreplacing,matrix,backgrounds}

\newcommand{\m}[0]{\mathbb}
\newcommand{\C}[0]{\mathcal}

\pagestyle{fancy}
\setlength{\parindent}{0mm}
\setlength{\headheight}{15.0pt}
\lhead{Angus Gruen, u5561004}
\rhead{Analysing Genomic Reads}
\title{Analysing Genomic Reads}
\author{Angus Gruen}

\begin{document}

\maketitle

\abstract{Given a reads file from a genome there are many methods that can be used to try and
extract information about the genome. This paper details algorithms which take a reads file and 
produce a $k$-mer counts file and then provides two approaches by which to extract information
about the underlying genomes from the $k$-mer counts file. Constructing a theoretical model of
frequency-frequency curves allows the the size of the original genome and the error rate in the
reads to be estimated. Alternatively, Kernel matrices can be used to estimate relative similarity
of a pair of genomes with respect to a larger set of genomes.}

\tableofcontents

\section{Introduction}

	\subsection{History}

		The ideas behind genetics originated in the $1860$'s with the paper	Experiments on Plant
		Hybridization by Gregor Mendel \cite{mendel}. This paper observed the inheritance
		properties of garden pea plants. Many years later, in the $1950$'s the Hershey-Chase
		experiment \cite{hershey chase} suggested that the material causing these inheritance
		properties was DNA which had, several years earlier, been shown to be made up of four
		nitrogenous bases, adenine, guanine, cytosine and thymidine.

		Moving forward $25$ years to $1977$, DNA was sequenced for the first time independently by
		Fred Sanger, Walter Gilbert and Allan Maxam. In $1990$ the Human Genome Project was
		started with the aim to map most $(92\%)$ of the Human Genome to an accuracy level of
		$99.99\%$. This was completed $13$ years later in $2003$. 

		What makes mapping a genome hard is that it is not currently possible to simply convert
		DNA extracted from an organism to a string in ACGT\footnote{The string corresponds to the
		sequence of the nitrogenous bases with each letter corresponding to the base with that
		initial}. What can be done instead is to break up the DNA into short segments, each
		containing around $100$ base pairs and then convert these shorter segments into a string
		in ACGT with a small error rate. These short segments are called reads and my project
		was fundamentally about what to do when given a file of reads from an unknown genome.
		One of the fundamental questions in this area is, given two reads files, is it
		possible to determine if they came from the same genome or, more generally, how
		similar the respective genomes are.

	\subsection{Related Work}

		The 1988 paper Genomic Mapping by Fingerprinting Random Clones: A Mathematical Analysis,
		by Eric S. Lander and Micheal S. Waterman \cite{genmap} gives a mathematical description
		of how to reconstruct the original genome from a reads file. Broadly speaking, given
		enough reads and computation power it is possible to reconstruct the original genome.
		Often however, we lack the quantity of reads or the computation power and so instead this
		project was looking at other ways to get information out.

		Graham Cormode and S. Muthukrishnan \cite{countmin, sketchs} discuss the Count-Min sketch
		used in the this project as well as giving an overview of other sketching methods used in
		big data analysis. Much of the early work done was adapting their methods to the
		particular problem and trying to find various optimisations based on the structure of the
		reads files and $k$-mers.

		In relation specifically to the modeling of frequency-frequency curves discussed in Section \ref{modff}, Michal Hozza, Tomas Vinar and Brona Brejova \cite{gensize}, give an alternate model to use to compute genome size and error rate. They model the curve using a truncated Poisson distribution as opposed to the bucket model used here.
		This method will produce identical curves at high coverage but there may be minor
		differences at low coverage. In particular, modeling using a Poisson distribution will
		improve the error free estimation but makes it more complicated to deal with the error
		rate in the reads.

		The papers \cite{specker} and \cite{D2word} look more in depth at different distance
		functions that could be used on sets of $k$-mer counts to generate different kernel matrices. These would be sensible places to look for methods to expand on the work done here.

	\subsection{Project Overview}

		There were two main problems that this project focused on. These corresponded to
		converting a reads file into a $k$-mer counts file and then looking at methods by which
		to analyse the $k$-mer counts file to get information about the underlying genome.

		Fixing a value of k, a $k$-mer counts file is list of the frequencies of words of length k
		in the given reads file. For large values of k and large reads files, making
		an exact $k$-mer counts file can be costly both from a time and memory standpoint. The
		first half of the semester was spent mainly on applying the techniques of sketching to
		this problem with the aim of producing approximate $k$-mer counts files in python in
		reasonable time.

		There were two separate approaches taken to analysing these files. The first was to
		compute a frequency-frequency curve. Given a $k$-mer counts file, create a discrete
		curve by calculating the number of $k$-mers that appear $i$ times. This curve is called a 
		frequency-frequency curve and allows an estimation of the size of the underlying genome as
		well as the error rate in the reads. The other approach is to
		compute a kernel matrix, broadly speaking, given several $k$-mer counts files and a 
		distance measure between two such files, a kernel matrix is a symmetric matrix whose
		$(i, j)$'th entry is the distance between $i$'th and $j$'th $k$-mer count file. Creating
		such a matrix allows for identification of reads coming from identical genomes as well as
		a measure of the relative similarities of the underlying genomes.

		Much of the semester was spent implementing already known methods and techniques from the
		aforementioned works however there were a couple of algorithms that I derived myself. Both
		the Exhaustive Count Min sketch described in Section \ref{ecm} and the model for
		frequency-frequency curves described in Section \ref{modff} were of my own creation.

\section{Generating k-mer Counts} \label{k-mer counts}

	The first problem to consider is what to do with a given reads file. There are two
	conflicting goals that make this problem difficult. On the one hand, it is important 
	for the information to be read independent. What this means is that two different
	read files from the same genome should produce a similar set of data. On the other
	hand, it is often important for the data to be genome dependant. If the aim is to 
	measure similarity between the underlying genomes, different genomes need to produce
	different data.

	The reason that these goals conflict is that in general, read independence
	is correlated with genome independence. In order get read independent information,
	some of the information contained in the reads needs to be discarded and, this
	naturally leads to some information about the genome being lost. 

	One method of getting information from reads is to consider the $k$-mer counts. The
	attractive feature of $k$-mer counts is that k can be varied to balance out these
	competing desires. This naturally leads to the question of what this value of k should 
	be.

	\subsection{Choosing k}

		If k is too small, then the	information taken from the reads file will be genome
		independent. For example setting k $= 1$, gives the distribution of A, C, G and T. While this is almost completely independent of the reads, it is also independent of the genome as there are many different genomes with similar distributions of A, C, G and T. Ideally,
		k should be large enough so that not all $k$-mers appear in any given genome. This
		forces a level of genome independence as, given any two different genomes, there will be
		some $k$-mers that appear in one genome but not the other. Empirically, it can be found that
		for k $< 14$, all $k$-mers will appear in any given genome.

		On the other hand if k is too large, it will be affected too much by the particular set of
		reads taken. Additionally, it will take more memory to store the $k$-mer counts file and
		more time to compute things with them. Finally, k needs to be an odd number. This comes
		from a biological standpoint as, given a strand of DNA, there are four possible words in 
		ACGT that could be read. These different possibilities come from the double helix 
		structure of DNA as the DNA might have been flipped upside down and there are two choices
		for the arm of the helix that is read. If k is even then it is possible for these effects
		to cancel out which would result in the corresponding words appearing with double the
		frequency of the other words. 

		Due to these effects, a commonly chosen value for k is $21$ and this is the value that
		will be used for most of this project. That being said, the ideas and results will carry
		over to different values of k and there is more analysis about the choice of $k$ in
		Section \ref{Kernels}.

		Unfortunately, setting $k$ to $21$ raises another problem, the number of 21-mers is
		$4^{21} > 10^{12}$ and so it is not practical in python to simply find the exact counts
		from a reads file. There are three different approaches that are use to combat this.
		The first is to use a different language (ada) which was implemented by Christfried
		Webers. The second and third methods are adaptations of the algorithm Count-Min Sketch
		described below.

	\subsection{Count-Min Sketch}

		The Count-Min sketch is a data structure developed as a solution to the count tracking
		problem where the number of objects being tracked is too large to directly list and 
		track them. In particular the Count-Min sketch trades some accuracy in the counts to
		massively reduce the amount of memory needed. The data array consists of fixed array of 
		width $w$ and depth $d$. For each row of the array there is an associated hash function
		$h_i$ which maps the set of all objects to a number in $[0, w - 1]$. It is important that
		these hash function all be independent and map the objects uniformly into the interval.

		When a new object $c$ is spotted, the sketch updates itself by incrementing the $h_i(c)$'th
		position in the $i$'th row by $1$ for every $i \in \{0, 1 \cdots, w - 1\}$. This is shown
		in Figure \ref{countmin image}. To estimate the number of times an object $c$ has been
		seen, take the minimum over $i$ of the values stored in the $h_i(c)$'th position in
		the $i$'th row.

		\begin{figure}[h!]
			\centering

			\includegraphics[width = \textwidth]{figures/countmin.png}

			\caption{A visual description of the Count-Min Sketch. Image comes from \cite{image}}
			\label{countmin image}
		\end{figure}

		Given some large amount $K$ of memory, a natural question to ask is how best to choose $w$
		and $d$ so as to maximise the accuracy of the sketch. This leads into some statistics which
		can be found in \cite{countmin} and the result is that the probability that the estimated count of an object overshoots the actual count by more than $\frac{2N}{w}$
		is $\frac{1}{2}^d$. Hence, to minimise the chance the the overshoot is more than $k$, $w$
		should be set to $\frac{2N}{k}$ and $d$ to $K/w$. The relationship between $w$ and $d$ for
		the specific case of $k$-mer counts will be further explored later on.

	\subsection{Generating k-mer counts files}

		There is still the question of how to translate a Count-Min sketch into $k$-mer counts.
		Due to the number of $21$-mers it is not possible to simply iterate through all 
		of them and so we need a method to reduce the number $21$-mers to be
		iterated through. There were several different solutions tried.

	\subsubsection{Exhaustive Count-Min (ECM)} \label{ecm}

			Imagine we are given a list $L$ of numbers between $1$ and $10^y - 1$ for some fixed $y$.
			The following is a method which can be used to construct a list of frequencies $(p, q)$
			with $p \in [0, 10^y-1]$ and $q$ the frequency of $p$ in $L$. A strength of this method
			is that it does not require storage of a list of length $10^y$ and so can be used for
			large values of $y$. Additionally, the method can offer large time savings over simply 
			iterating over $10^y$ objects.

			As described earlier, the Count-Min sketch gives a function $f$ such that for a given $p$,
			$f(p)$ is an approximation of $q$. At the same time as setting up the sketch\footnote{So
			we only have to iterate through the list once}, pick some $0 < z < y$ such that $10^z$ is
			manageable\footnote{In the sense that it is possible to store a list of	length $10^z$}.
			Create a boolean list $Q$ of length $10^{z}$ filled with False (F). Then, for each $l$ in
			$L$, add zeroes to the front of $l$ until it has $y$ digits and denote $g_l$ the
			number formed by taking the first $z$ digits. Set the $g_l$'th element of $Q$ to True (T).
			This method of updating is visualised in Figure \ref{ecm diagram}.

			\begin{figure}
				\centering

				\begin{tikzpicture}
		    		[%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		        		font=\ttfamily,
						array/.style={matrix of nodes,nodes={draw, minimum size=7mm, fill=green!30},column sep=-\pgflinewidth, row sep=0.5mm, nodes in empty cells,
						row 1/.style={nodes={draw=none, fill=none, minimum size=5mm}}},
						box/.style={rectangle,draw=black, ultra thick, minimum size=1cm},
		    		]%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

					\foreach \y [count=\x] in {0,6,1,9,7,3,2,5,6,4}{\node[box] at (\x-1,0){\y};}

					\draw[decorate,decoration={brace,mirror},thick] (-.5,-.7) -- node (V) [below]{$g_l = 619732$} (6.5,-.7);
					\draw[decorate,decoration={brace,mirror},thick] (6.5,-.7) -- node[below]{Ignored} (9.5,-.7);



					\matrix[array] (array) at (8, -2) {
						0 & 1 &  $\cdots$ &  619732 & $\cdots$ & 9999999 \\
						  &   &   &   &   &  \\};
						\node[draw] (T) at (array-2-4) {T};

					\draw[red, very thick, ->] (V) to[bend right=65] (T);

				\end{tikzpicture}

				\caption{Updating a prefix array from a seen value $l = 619732564$ with $y = 10$ with $z = 7$.}
				\label{ecm diagram}

			\end{figure}

			To constructing the frequency list, iterate through $Q$ and whenever a True is found with
			index $g$, iterate $i$ through $[0, 10^{y - z} - 1]$ and add the pairs $(10^{y - z}g + i,
			f(10^{y - z}g + i))$ to the frequency list. Computational savings from this algorithm occur if there some
			sparsity in $Q$. If $q\%$ of the elements in $Q$ are True, then the number of
			operations needed via this method is of complexity $10^z + \frac{q}{100}(10^y)$. This can be a huge saving over the $10^y$ needed for the direct approach.

			In the described method we are implicitly working in base $10$ with our numbers between
			$0$ and $10^y - 1$ and the boolean list of size $10^z$.	It should be clear however
			that there is nothing special about $10$. The method will still work  with $10$ replaced 
			by any other positive integer $b$. This allows generalisation of this method to genomes.

			Imagine we are gives a reads file and wish to construct a $21$-mers counts file. A word
			in ACGT can be thought of as a number in base $4$ by associating $A$ with $0$, $C$ with
			$1$, $G$ with $2$ and $T$ with $3$. Hence the above algorithm described can be adapted to
			create the boolean list. Figure \ref{ecm genome} shows an explicit example of updating
			when dealing with genomes. For the homemade genomes, setting $z = 15$ we find that
			$q \sim 4^{-6}$	and so the number of operations is reduced from $4^{21}$, to $2\times
			4^{15}$. This is a manageable number and so allows a conversion from a Count-Min sketch to
			a $k$-mer counts file.

			\begin{figure}
				\centering

				\begin{tikzpicture}
		    		[%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		        		font=\ttfamily,
						array/.style={matrix of nodes,nodes={draw, minimum size=7mm, fill=green!30},column sep=-\pgflinewidth, row sep=0.5mm, nodes in empty cells,
						row 1/.style={nodes={draw=none, fill=none, minimum size=5mm}}},
						box/.style={rectangle,draw=black, ultra thick, minimum size=1cm},
		    		]%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

					\foreach \y [count=\x] in {T,A,T,C,A,G,G,T,T,A}{\node[box] at (\x-1,0){\y};}

					\draw[decorate,decoration={brace,mirror},thick] (-.5,-.7) -- node (V) [below]{TATCAGG $\rightarrow 3031022_4$} (6.5,-.7);
					\draw[decorate,decoration={brace,mirror},thick] (6.5,-.7) -- node[below]{Ignored} (9.5,-.7);

					\matrix[array] (array) at (8, -2) {
						$0_4$ & $1_4$ &  $\cdots$ &  $3031022_4$ & $\cdots$ & $3333333_4$ \\
						  &   &   &   &   &  \\};
						\node[draw] (T) at (array-2-4) {T};

					\draw[red, very thick, ->] (V) to[bend right=65] (T);

				\end{tikzpicture}

				\caption{Updating a prefix array from a 10-mer with $z = 7$}
				\label{ecm genome}

			\end{figure}

		\subsubsection{Sorted Count-Min (SCM)}

			There is another option for converting a Count-Min sketch into a $k$-mer counts file. The idea behind this method is that, while creating the Count-Min sketch, also record a set of all observed $k$-mers. Then, to generate the $k$-mer counts, simply sort this list and then iterate through it, finding the frequency of each one. The reason for sorting the list is because many of the operations that will be computed on the $k$-mer counts files are massively sped up if the files are sorted.

		\subsubsection{Frequency Counts}

			The final and simplest algorithm is Frequency Counts. This algorithm does not create a
			$k$-mer counts file but directly produces a frequency frequency curve which, often,
			is what the $k$-mer counts are used for anyway. The idea is to create a Count-min
			sketch with	only a single hash function and then creates a frequency list of the resulting array as an approximation to a frequency frequency curve.

	\subsection{Comparing the different Counting Techniques}

		Gantc is an algorithm written by Christfried Webers in
		Ada to do exact counts of $k$-mers. This will be used as the
		ground truth to compare the	aforementioned algorithms against.

		The method of the experiment was reasonably simple. Gantc was run over $10$ homemade
		genomes to establish a ground truth. Then, the ECM and SCM were run with several different values for the number of hash functions and the size of the Hash array. Additionally,
		the Frequency counts algorithm was run with two different sizes of the Hash array. The
		error in the generated $k$-mer counts and frequency frequency curves was then computed
		by the ratio of the number of differences between the file generated by Gantc
		and a given file divided by number of values in the given file. This is a good method for
		the difference between $k$-mer files but turns out to be relatively meaningless as a measure
		of the difference between two frequency frequency curves.\footnote{The experiment can be
		repeated with the line experiment.py [[8,24],[4,25],[2,26]] [[8,24],[2,26]] [24, 26] True
		on a windows computer or False on a different operating system. You also need to make sure
		that the $-c$ command is not present in steam/gantc} The results from this experiment can
		be seen in Table \ref{kmer experiment}. 

		\begin{table}

			\centering

			\begin{tabular}{ |p{2cm}|p{2cm}|p{2cm}|p{2cm}|p{2cm}| }
				\hline
				\multicolumn{5}{|c|}{$k$-mer Frequency Results Table} \\
				\hline
				Method & Number of Hash Functions & Size of Hash Array &  Time Taken $(s)$ & \% Error \\
				\hline
				ECM & $8$ & $2^{24}$ &  $1400$ & $0$ \\
				\hline
				ECM & $4$ & $2^{25}$ &  $1316$ & $0.00061\%$ \\
				\hline
				ECM & $2$ & $2^{26}$ &  $1283$ & $3.9\%$ \\
				\hline
				SCM & $8$ & $2^{24}$ &  $164$ & $0$ \\
				\hline
				SCM & $2$ & $2^{26}$ &  $56$ & $0.011\%$ \\
				\hline
				Frequency Counts & $1$ & $2^{24}$ & $30$ & $100\%$ \\
				\hline
				Frequency Counts & $1$ & $2^{26}$ & $31$ & $100\%$ \\
				\hline
			\end{tabular}

			\caption{Time and error estimation for the different sketch methods with different allocations of memory}

			\label{kmer experiment}

		\end{table}

		Overall Table \ref{kmer experiment} shows that the strength of Frequency Counts is in its speed. Similarly, SCM is much faster and more accurate than ECM for this genome size. The reason for this is that SCM never checks the frequency of a $k$-mer which does not appear in reads. Checking such $k$-mers slows ECM down and can produce ghost $k$-mers\footnote{A ghost $k$-mer is a $k$-mer that does not appear in the reads but has a non 0 frequency in the created $k$-mer Frequency file} in the $k$-mer counts file which reduces accuracy.

		The main weakness of SCM will be its poor scaling with the size of the read file and genome as the sorting operation will become slow. As ECM theoretically scales better it should eventually overtake SCM in speed for large genomes with higher coverage read files. 

		The results also show that splitting up a Count-Min array by adding more rows improves the accuracy of the resulting sketch at a slight time cost. Additionally, for these small files, Frequency Counts is not offering a big time save over SCM and, as SCM produces error free data with 8 hash functions, SCM is the best methods to be using.

		To investigate the time difference between ECM and SCM further cProfile was run over ECM to get a breakdown of where time is consumed. The results showed that the main
		consumers of time is simply the large number of times that certain functions are
		called. This suggests that the most sensible way to speed it up would be to make these
		functions faster or, to find ways to reduce the number of times they need to be called.

		Overall, there are are several methods by which to create a $k$-mer counts file or a frequency
		frequency curve from a reads file. Moving on, the question becomes what to do with these
		created files.

\section{Analysing k-mer counts files} \label{analysis}

	Analysing $k$-mer counts files fundamentally comes down to finding methods of
	extracting information which are read independent. Two very different approaches
	are to construct frequency-frequency curves and kernel matrices.
	frequency-frequency curves give a method to take a reads file and 
	estimate both the genome size and the error rate in the reads. Alternatively,
	kernel matrices allow an estimation of the relative similarities between pairs 
	of genomes contained in a larger set of genomes.

	\subsection{Frequency-Frequency Curves}

		Given a reads file, construct the corresponding $k$-mer counts file as
		described in the previous section. Then, find the number of $k$-mers $(k_n)$
		that appear $n$ times in the file for each $n \in \{1, \cdots, N\}$
		where $N$ is the total number of $k$-mers in the reads file. 
		This gives a discrete curve with features that depend mainly on the
		level of coverage and the error rate in the	reads. Six frequency-frequency curves are
		shown in Figure \ref{freq-freq curves} each at a different coverage level.
		There are a couple of key features to
		observe in these curves. Note the peak when $x$ is roughly the coverage level and,
		for high coverage, the peak at $x = 1$ caused by the error rate.

		\subsection{Modeling Frequency-Frequency Curves} \label{modff}

			Let $n_i$ be the actual number of $k$-mers that appear in the genome with frequency $i$.
			As the genome is finite there is some $m_1 \in \m{N}$ such that $n_i = 0$
			for $i > m_1$. Define $\{K_{i, j}\}$ with $0 < i \leq m_1$ and $0 < j \leq n_i$ to be
			the set of $k$-mers appearing in the genome.

			Model taking a reads file $H$ as drawing $N$ $k$-mers
			out of a bucket with some error rate $\epsilon$. Initially assume
			that $\epsilon = 0$. Define $H_{i, j}$ to be the number of appearances
			of the $k$-mer $K_{i, j}$ in the reads. Then the probability
			of a reads file $H$ can be found using a sampling with replacement model.
			\begin{equation} \label{ProbH}
				p(H) = N! \prod_{0 < i \leq m_1, 0 < j \leq n_i} \frac{1}{H_{i, j}!} \left(\frac{i}{N}\right)^{H_{i, j}}.
			\end{equation}
			Let $F$ be a function that takes $k$-mer frequency data and produces 
			frequency-frequency data. Hence $F(H)_i$ is the number 
			of $k$-mers that appear in $H$ with frequency $i$. Additionally,
			let $\C{H}$ refer to a particular set of frequency-frequency data where $\C H_i$ is
			the number of $k$-mers that appear $i$ times, then
			\begin{equation}
				p(\C{H}) = \sum_{H \in F^{-1}(\C{H})} p(H).
			\end{equation}
			Using python notation of True $= 1$ and False $= 0$, $F^{-1}$ is
			\begin{equation}
				F^{-1}(\C{H}) = \left\{H: \C H_i = \sum_{0 < l < m, 0 < j \leq n_l} \big(H_{l, j} == i\big)\right\}.
			\end{equation}

		\newpage

		\thispagestyle{plain}
		\newgeometry{top=0.1cm,bottom=0.1cm,left=0.1cm,right=0.1cm}

		\begin{figure}
			\hspace{-1.5cm}
			\includegraphics[width = 235mm]{figures/freq_freq_curves.png}
			\caption{Frequency-Frequency curves at different levels of Coverage}
			\label{freq-freq curves}
		\end{figure}	

		\restoregeometry

		\newpage

			The aim of this section is to find $\C{H}_{ML}$, the most likely 
			frequency-frequency curve from taking $N$ $k$-mers from a genome.
			Let $m_2 \in \m N$ be the integer such that $\C{H}_i = 0$ for $i \geq m_2$.
			Then,
			\begin{gather}
				\label{Consevation of k-mers 1} \sum_{i = 1}^{m_1} n_i = \sum_{i = 0}^{m_2} \C{H}_i 
				\\ \label{Consevation of k-mers 2} \sum_{i = 0}^{m_2} i\C{H}_i = \sum_{i = 1}^{m_1} \sum_{j = 1}^{n_i} H_{i, j} = N.
			\end{gather}

			Consider again equation \ref{ProbH}, using \ref{Consevation of k-mers 2}
			and defining $H_i = \sum_{j = 0}^{n_i} H_{i, j}$ we can write this as
			\begin{equation} \label{SimpProbH}
				P(H) = \frac{N!}{N^N} \prod_{i = 1}^{m_1} i^{H_i} \prod_{j = 1}^{n_i} \frac{1}{H_{i, j}!}.
			\end{equation}
			This leads to calculating the multiplicity in a state $H$. The idea is
			that if $H_{i, j} \neq H_{i, k}$ for some $j, k$ then we could swap 
			the frequencies of $K_{i, j}$ and $K_{i, k}$ without changing $P(H)$ or
			$F(H)$. Define $c_{i, x}$ to be number of occurrences of the number 
			$x$ in the set $\{H_{i, j}\}_{0 < j \leq n_i}$. Then $H_i = \sum_{x = 0}^{H_i}x c_{i, x}$
			and $\C H_i = \sum_{x = 1}^{m_1} c_{x, i}$. The multiplicity associated
			to distribution of $H_i$ among $H_{i, j}$ is 
			$(H_i)!\prod_{x = 0}^{H_i} \frac{1}{c_{i, x}!}$. Therefore the 
			multiplicity associated to a state $H$ is
			\begin{equation} \label{multiplicity}
				\prod_{i = 1}^{m_1} (H_i)! \prod_{x = 0}^{H_i} \frac{1}{c_{i, x}!}
			\end{equation}
		
			This leaves us to work out the different $H's$ that can be 
			associated to each $\C H$. This can simply be viewed as a bucket
			problem. We want to find the number of ways to put $\C H_1 \ 1$'s, $\C H_2 \ 2$'s
			so on so forth into $m_1$ buckets so that there is $n_1$ numbers
			in the first bucket, $n_2$ in the second bucket and so on so forth.

			This turns out to be a difficult problem and so make the approximation that $m_1$ is
			equal to $1$. The justification for this is that the number of possible $k$-mers is much
			larger than the size of a genome
			and so most $k$-mers only appear once. This solves the aforementioned problem
			to be $1$ regardless of $\C H$ as there are no choices to make. Additionally, it
			simplifies Equation \ref{SimpProbH} to
			\begin{equation}
				P(H) = \frac{N!}{N^N} \prod_{j = 1}^{n_1} \frac{1}{H_{1, j}!}.
			\end{equation}
			Then multiplying equations 7 and 8 gives
			\begin{equation}
				p(\C{H}) = \frac{N!(H_1)!}{N^N} \prod_{j = 1}^{n_1} \frac{1}{H_{1, j}!} \prod_{x = 0}^{H_1} \frac{1}{c_{1, x}!} .
			\end{equation}
			As $N$ and $H_1$  are constants, $\C{H}_{ML}$ can be found by maximising
			\[
				\prod_{j = 1}^{n_1} \frac{1}{H_{1, j}!} \prod_{x = 0}^{H_1} \frac{1}{c_{1, x}!}
			\]
			As $m_1 = 1$, $c_{1, x} = \C H_x$. Additionally, the number of $H_{1, j}$ equal
			to some $k$ is precisely $\C H_k$. Therefore the above equation can be rewritten as
			\[
				\prod_{i = 1}^{N} \left(\frac{1}{i!}\right)^{\C H_i} \frac{1}{(\C H_i)!}.
			\]
			This is a constrained maximisation problem with constraints given in Equations
			\ref{Consevation of k-mers 1} and \ref{Consevation of k-mers 2}. Given an $N$ and
			and $n_1$ maximise over the discrete lattice as follows.

			First, to keep calculations small, take the negative log giving
			\[
				G(\C H_1, \cdots, \C H_{N}) = \sum_{i = 1}^{N} \C H_i \log(i!) + \log((\C H_i)!).
			\]
			Next, calculate the discrete partial derivatives in each of the $\C H_i$ directions.
			\[
				G(\C H_1, \cdots, \C H_i + 1, \cdots, \C H_{N}) - G(\C H_1, \cdots, \C H_{N}) = \log(i!) + \log(\C H_i + 1).
			\]
			Similarly, taking a partial derivative in the negative direction yields
			\[
				G(\C H_1, \cdots, \C H_i - 1, \cdots, \C H_{N}) - G(\C H_1, \cdots, \C H_{N}) = -\log(i!) - \log(\C H_i).
			\]
			Movement around this lattice is restricted by the constraints
			\begin{gather*}
				\sum_{i = 0}^{N} \C H_i = n_1
				\\ \sum_{i = 0}^{N} i\C H_i = N.
			\end{gather*}
			The first constraint means that for each $\C H_i$ decremented some $\C H_j$ must be incremented and second constraint says that if some set $\C H_{i_1}, \cdots, \C H_{i_m}$ is decremented and another set $\C H_{j_1}, \cdots, \C H_{j_m}$ is incremented then
			\[
				\sum_{k = 1}^{m} i_k = \sum_{k = 1}^{m} j_k.
			\]
			From this it should be clear that movement around the lattice
			can be broken down into steps of incrementing a pair $\C H_{i_1}, \C H_{i_2}$
			and decrementing a pair $\C H_{j_1}, \C H_{j_2}$ with 
			$i_1 + i_2 = j_1 + j_2$.\footnote{This algorithm is implemented by the function
			distfinder in Angus/experiment.py.}

			A nice feature of this model is that the error rate can easily
			be incorporated as drawing out of a different bucket with probability $\epsilon$.
			With the assumption that all errors occur with $1$ base changed and there are no
			collisions between errors of different $k$-mers or errors and other $k$-mers, the
			number of $k$-mers in the new bucket will be $63n_1$. Hence if $N$ samples are drawn,
			$\C{H}_{ML}$ can be found by running the above algorithm twice with	parameters $(n_1, (1 - \epsilon)N)$ and $(63n_1, \epsilon N)$ and summing the resultant curves together.
			This produces the curves shown in Figure \ref{theory vs reality}.\footnote{This algorithm is implemented by the function err\_distfinder in Angus/experiment.py. The curves can be found in the Jupyter Notebook: Testing Frequency - Frequency data for different levels of Coverage.}

			So far, the assumption has been that the number of $k$-mers	in the genome and
			the error rate in the reads is known and the aim is to find the frequency-frequency curve. It is possible however, to reverse this and from a frequency-frequency curve estimate the number of $k$-mers	in the genome and the error rate in the reads.

			This reversal requires an error function to	measure the difference between two curves.
			Let $P, Q$ be two frequency-frequency curves with height at $i$ denoted $P_i, Q_i$.
			There are several functions that could be used. Given the similarity that frequency-frequency curves have to probability measures, the Total Variation (TV) or Hellinger distance (H) are functions to try. These are defined as
			\begin{gather*}
				TV(P, Q) = \sum_{i} |P_i - Q_i|
				\\ H(P, Q) = \sum_{i} (\sqrt{P_i} - \sqrt{Q_i})^2
			\end{gather*}
			Another option, is to try and develop an error function from scratch. As mentioned earlier, there are two important features of frequency-frequency curve. The central peak and, the peak at $1$. Hence consider the error function Peak Difference defined by
			\begin{align*}
				\delta(P, Q) & = \left|\log\Big(\frac{P_1}{Q_1}\Big)\right| + 
				\frac{1}{2}\left|\log\Big(\frac{P_2}{Q_2}\Big)\right| + 
				\left|\log\Big(\frac{P_{max}}{Q_{max}}\Big)\right|
				\\ & + \frac{1}{2} \left|\log\Big(\frac{P_{max - 1}}{Q_{max - 1}}\Big)\right|	
				+ \frac{1}{2} \left|\log\Big(\frac{P_{max + 1}}{Q_{max + 1}}\Big)\right|
			\end{align*}
			The first two terms relate to the peak at $1$ and how is decays and the other three terms are measuring the central peak.\footnote{If the central peak is at $1$ then only the first $2$ terms are calculated}
			
			\newpage

			\thispagestyle{plain}
			\newgeometry{top=0.1cm,bottom=0.1cm,left=0.1cm,right=0.1cm}

			\begin{figure}
				\hspace{-1.5cm}
				\includegraphics[width = 235mm]{figures/Theory_vs_Reality.png}
				\caption{Comparing the theoretical and experimental curves.}
				\label{theory vs reality}
			\end{figure}

			\restoregeometry

			\newpage

			Treating the distance function as an objective function to be minimised gives an optimisation problem but it is not clear that there will be a unique local minimum. Figure \ref{heatmaps for Convergence} shows that with the Total Variation and Hellinger metrics, the error depends almost entirely on the the genome size until variation in the genome size is tiny. On the other hand the Peak Difference has a much nicer valley shape especially with lower variation.

			This shows that provided the initial point is not too far away from the
			correct genome size, there should be convergence too a local minimum. Hence we need
			to find a method to get a good initial guess. A simple initial estimate for high
			coverage is to take the minimum between the two peaks in the graph and then label
			everything to the left an error and everything to the right an observed $k$-mer. For
			lower coverage it is more difficult so an approximation is to guess the error rate to be a small constant\footnote{In the experiment to create Table \ref{freq results},
			$\epsilon$ was set to $0.01$.} $\epsilon$ and approximate the genome size by
			$1 - \epsilon$ multiplied by the number of observed $k$-mers in the frequency graph.

			As the objective function is not differentiable, a combination of coordinate descent and golden section search was used as a minimisation method. This was trialled on two different coverage levels of one of the artificial genomes. The results of this experiment can be seen in the table below. Note that something not in the table is the speed of convergence, while the speed was basically identical for all the distance functions, it took much longer at the lower coverage level.\footnote{This experiment can be found in the Jupyter notebook Estimating Genome Size and Error Rate.}

			As can be seen in Table \ref{freq results}, at high coverage, both the Total Variation
			and Hellinger Distances produce results that are very close to the actual value.
			Additionally, at low coverage, while the genome size is estimated well, the error rate
			is overestimated. Figure \ref{gen freq freq} shows the Frequency Frequency curves
			created by the approximation method. The similarity between them justifies that the
			convergence algorithm is converging sensibly.

			Overall, computing the frequency-frequency curves gives a method by which to 
			estimate the size of the original genome and the error rate in the reads.
			Unfortunately, it does not tell us much more than that, two very different
			genomes of comparable size will have similar frequency-frequency curves.
			To get a measure of similarity, we need a different method such as computing
			a Kernel Matrix.

			\newpage

			\thispagestyle{plain}
			\newgeometry{top=0.1cm,bottom=0.1cm,left=0.1cm,right=0.1cm}

			\begin{figure}
				\centering
				\includegraphics[width = 65mm]{figures/high_d.png}
				\includegraphics[width = 65mm]{figures/high_tv.png}
				\includegraphics[width = 65mm]{figures/high_h.png}
				\\
				\includegraphics[width = 65mm]{figures/medium_d.png}
				\includegraphics[width = 65mm]{figures/medium_tv.png}
				\includegraphics[width = 65mm]{figures/medium_h.png}
				\\
				\includegraphics[width = 65mm]{figures/low_d.png}
				\includegraphics[width = 65mm]{figures/low_tv.png}
				\includegraphics[width = 65mm]{figures/low_h.png}
				\caption{Heatmaps for Distance function}
				\label{heatmaps for Convergence}

				\vspace*{\floatsep}

				\includegraphics[width=100mm]{figures/high_coverage_estimates.png}
				\includegraphics[width=100mm]{figures/low_coverage_estimates.png}
				\caption{The generated frequency-frequency curves.}
				\label{gen freq freq}
			\end{figure}

			\restoregeometry

			\newpage

			\begin{table}

				\centering

				\begin{tabular}{ |p{4cm}|p{2cm}|p{2cm}|p{2cm}| }
					\hline
					\multicolumn{4}{|c|}{Trial on $200000$ $k$-mer Genome with a $0.16 \%$ Error Rate} \\
					\hline
					Difference Function & Coverage & Estimated Genome Size & Estimated Error \\
					\hline
					Total Variation & $25X$ & $199584$ &  $0.160 \%$ \\
					\hline
					Hellinger & $25X$ & $199207$ & $0.161 \%$ \\
					\hline
					Peak Difference & $25X$ & $196536$ &  $0.254 \%$ \\
					\hline
					Total Variation & $3X$ & $198461$ &  $0.241 \%$ \\
					\hline
					Hellinger & $3X$ & $196752$ &  $0.377 \%$ \\
					\hline
					Peak Difference & $3X$ & $198471$ &  $0.775 \%$ \\
					\hline
				\end{tabular}

				\caption{Genome size and error estimation with the three different distance functions for two different coverage levels}

				\label{freq results}

			\end{table}

	\subsection{Estimating Similarity using Kernel Matrices} \label{Kernels}

		Ideally, given two sets of reads with high enough coverage, it should be possible 
		to determine if the reads were taken from the same genome or, more generally,
		how similar the original genomes were. Kernel Matrices are an attempt to solve this
		problem. Specifically, given a reads file produce the $k$-mer counts as discussed in Section \ref{k-mer counts}. Then, given two counts, treat these	as vectors in a $4^k$ dimensional space and take the inner product. Given a set of $n$
		counts, this produces a symmetrical $n\times n$ matrix where the $i, j$'th entry is the
		inner product of the $i$'th	count and the $j$'th count. This matrix is called a kernel
		matrix. Note that there are other ways to create kernel matrices but this paper will
		only focus on this one.\footnote{\cite{specker} and \cite{D2word} discuss different formulations of kernel matrices} Visualizing this matrix as a heat map allows an observation of the relative similarities between different reads files.

		To investigate further, several experiments were conducted on a large sets of reads
		containing reads from eight different bacterial genomes with five reads at each of five
		different coverage levels. Using Gantc, $k$-mer counts for $6$ different values of $k$ for
		the lowest and middle coverage levels were computed as well as the $k$-mer counts for all
		coverage levels with $k$ set to $21$. These were then converted to Kernel Matrices again
		using Gantc.\footnote{The code for this can be found in kernel\_analysis.py and file was
		run with the lines python kernel\_analysis.py [1,7,15,21,51,99] [0,2] and python
		kernel\_analysis.py [21] [0,1,2,3,4]} To improve the visualisation, the displayed heatmaps have taken the natural log of every non $0$ entry leaving the the $0$ entries still at $0$.

		The first experiment was to test the effect of changing the value of $k$ on the matrices.
		In particular it gives a more explicit description of what happens if $k$ is too
		large or small. There are several features to look for in the heatmaps that indicate
		a good value of $k$. The way the matrix was set up, the $5$ counts relating to the
		same bacteria are adjacent. This means that the heatmaps have a central diagonal of
		eight, $5\times 5$ matrices corresponding to the similarity of five different reads file from the same genome to each other. Ideally, all of the cells in this central diagonal should be brighter than
		any other cell on the same row or column outside the $5\times 5$ matrix. The
		interpretation for this is that two reads files from the same genome should be more
		similar than reads files from different genomes.

		Another property to observe is read independence. If the information coming from the
		reads is read independent then the $40\times 40$ matrix will look like an $8\times 8$
		matrix as different reads from the same genome will produce similar inner products with
		other sets of reads. Finally, though this is a smaller point, there should not be many
		$0$'s in the kernel matrix. A $0$ in the matrix corresponds to a pair of $k$-mer counts with
		no overlap. While some $0$'s may be unavoidable for low coverages, if the kernel matrix is
		heavily populated by $0$'s then it cannot give an effective measure of similarity. It can
		only test if two reads are from the same genome or not.

		Glancing at Figure \ref{low coverage}, it is immediately clear that setting k equal to
		$1, 7, 51$ or $99$ produces bad data. The matrices corresponding to values of $1$ and $7$ do not have a bright central diagonal and setting $k$ to $51$ or $99$ gives sparse
		matrices with $0$'s everywhere. On the other hand, k values of $15$ and $21$ look much more
		promising. For both of these values there is a bright diagonal and neither has many $0$'s. Looking closely at the matrices, for low coverage $15$ is probably a better
		value for k as the matrix looks more like an $8\times 8$ matrix and so the information
		is more read independent.

		Increasing the coverage of the reads gives Figure \ref{med coverage}. Note that the
		kernels corresponding to $1$ and $7$ are basically unchanged. This is to be expected as
		Figure \ref{low coverage} showed that $1$-mers and $7$-mers were already read independent and
		so increasing the number of reads simply increases the numbers. Similarly, while the
		kernel created with $99$-mers is looking at little better it is still filled with $0$'s.

		The big change in Figure \ref{med coverage} is the kernel created from the $51$-mers.
		Increasing the coverage has massively filled this kernel out and it now looks much more
		promising to be used as a measure of similarity. Similarly, k values of $15$ and $21$
		are almost completely read independent at this level of coverage as their corresponding
		kernel matrices look almost exactly like $8\times 8$ matrices. At this coverage level the
		optimal value for $k$ is probably $21$. This is because $21$-mers naturally have more
		information contained in them than $15$-mers and so if all else is equal they will give a
		better measure of similarity. Additionally, while the $51$-mers produce a nicer matrix
		at this higher coverage compared to at the lower coverage level, the data is still a little to
		read dependant.

		The other experiment conducted on the Kernel matrices was a more in depth look at
		how coverage changes the look of the matrices for a fixed value of k, chosen to be
		21. Judging by the first experiment, the expectation is that the matrices to look overall
		similar but the $5\times 5$ sub matrices to become smoother as the coverage increases.
		This is exactly what can be observed in Figure \ref{Heatmap of 21-mers}. Particularly
		after the lowest two coverage levels, the full $40\times 40$ matrices look almost
		identical. This suggests that high coverage is unimportant for construction of kernel
		matrices with a k-length of $21$. Moreover the chosen value for $k$ should change with the
		coverage level. Setting $k$ to $21$ will always be a good value but for low coverage
		lowering $k$ will be more effective and for high coverage, increasing $k$ will give better similarity estimates.

		\section{Conclusion}

		Given a organism, it is possible, using biology to create a large file of reads
		corresponding to short 100-length segments of DNA. Section \ref{k-mer counts}
		describes several methods by which to covert a reads file into a $k$-mer counts
		file. In particular, it discusses sketching as a method to create good approximations to these files with vastly lower memory requirements. In particular, Section \ref{ecm} describes an algorithm I created to covert a reads file to a $k$-mer counts file.

		Section \ref{analysis} talks about various ways by which to get information out of
		a $k$-mer counts file. Specifically, Section \ref{modff} discusses the model I developed
		for frequency frequency curves and how to use this model to estimate the genome size
		and the error rate in the reads. Section \ref{Kernels} introduces Kernel Matrices as a
		method to estimate similarity between genomes and discusses how changing the length of $k$ or the level of coverage affects the produced Kernel	Matrix.

		There are many methods by which this project could be expanded on in the future. The
		ECM algorithm developed could be developed more so as to give a better signal of which
		$k$-mers could possibly appear in the genome. Additionally there is much more that could
		be done with Kernel Matrices such as using a different distance function to generate them
		or investigating how best to normalise them. There are also other ways in which to 
		analyse a $k$-mer counts file as well as other models of frequency frequency curves that could be looked into.

		\newpage

		\thispagestyle{plain}
		\newgeometry{top=0.1cm,bottom=0.1cm,left=0.1cm,right=0.1cm}

		\begin{figure}[!htbp]
			\centering
			\subfloat[1-mers]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Low_Coverage_1}
			}
			\subfloat[7-mers]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Low_Coverage_7}
			}
			\hspace{0mm}
			\subfloat[15-mers]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Low_Coverage_15}
			}
			\subfloat[21-mers]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Low_Coverage_21}
			}
			\hspace{0mm}
			\subfloat[51-mers]{   
			  \includegraphics[width=85mm]{figures/log_heatmap_Low_Coverage_51}
			}
			\subfloat[99-mers]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Low_Coverage_99}
			}
			\caption{Heatmaps for different values of k at a 0.1X Coverage level} \label{low coverage}
		\end{figure}

		\newpage
		\thispagestyle{plain}

		\begin{figure}[!htbp]
			\centering
			\subfloat[1-mers]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Med_Coverage_1}
			}
			\subfloat[7-mers]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Med_Coverage_7}
			}
			\hspace{0mm}
			\subfloat[15-mers]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Med_Coverage_15}
			}
			\subfloat[21-mers]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Med_Coverage_21}
			}
			\hspace{0mm}
			\subfloat[51-mers]{   
			  \includegraphics[width=85mm]{figures/log_heatmap_Med_Coverage_51}
			}
			\subfloat[99-mers]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Med_Coverage_99}
			}
			\caption{Heatmaps for different values of k at a 5X Coverage level} \label{med coverage}
		\end{figure}

		\newpage

		\thispagestyle{plain}

		\begin{figure}[!htbp]
			\centering
			\subfloat[0.1X Coverage]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Low_Coverage_21}
			}
			\subfloat[1X Coverage]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Low_Med_Coverage_21}
			}
			\hspace{0mm}
			\subfloat[5X Coverage]{
			  \includegraphics[width=85mm]{figures/log_heatmap_Med_Coverage_21}
			}
			\subfloat[10X Coverage]{
			  \includegraphics[width=85mm]{figures/log_heatmap_High_Med_Coverage_21}
			}
			\hspace{85mm}
			\subfloat[30X Coverage]{   
			  \includegraphics[width=85mm]{figures/log_heatmap_High_Coverage_21}
			}
			\caption{Heatmaps of kernel matrix for $21$-mers at  different coverage levels} \label{Heatmap of 21-mers}
		\end{figure}

		\restoregeometry
		\newpage

	\begin{thebibliography}{9}

		\bibitem{mendel}
			Gregor Mendel.
			\textit{Experiments in Plant Hybridization}
			\\ \texttt{http://www.esp.org/foundations/genetics/classical/gm-65.pdf}
			1865

		\bibitem{hershey chase}
			A. D. Hershey, Martha Chase
			\textit{Independent functions of Viral Protein and Nucleic Acid in growth of Bacteriophage}
			\\ \texttt{http://jgp.rupress.org/content/jgp/36/1/39.full.pdf}
			Department of Genetics, Carnegie Institute of Washington, 1952


		\bibitem{countmin}
			Graham Cormode and S. Muthukrishnan.
			\textit{Approximating Data with the Count-Min Data Structure}
			\\ \texttt{http://dimacs.rutgers.edu/~graham/pubs/papers/cmsoft.pdf}
			2011


		\bibitem{genmap}
			Eric S. Lander and Micheal S Waterman.
			\textit{Genomic Mapping by Fingerprinting Random Clones: 
			A Mathematical Analysis}
			\\ \texttt{https://www.ncbi.nlm.nih.gov/pubmed/3294162}
			Whitehead Institute for Biomedical Research, 1988

		\bibitem{gensize}
			Michal Hozza, Tomas Vinar, and Brona Brejova.
			\textit{How Big is that Genome? Estimating Genome Size and Coverage
			from $k$-mer Abundance Spectra}
			\\ \texttt{https://link.springer.com/chapter/10.1007/978-3-319-23826-5\_20}
			Faculty of Mathematics, Physics and Informatics, Comenius University, 2015

		\bibitem{sketchs}
			Graham Cormode
			\textit{Sketch Techniques for Approximate Query Processing}
			\\ \texttt{http://dimacs.rutgers.edu/~graham/pubs/html/Cormode11sketch.html}
			Foundations and Trends in Databases, 2011

		\bibitem{specker}
			Christina Leslie, Eleazar Eskin, William Stafford Noble
			\textit{The Spectrum Kernel: A string kernel for SVM protein classification}
			\\ \texttt{http://www.ics.uci.edu/~welling/teatimetalks/kernelclub04/spectrum.pdf}
			PSB 2002, pp 564--575

		\bibitem{D2word}
			Sylvain Foret, Susan R. Wilson, Conrad J. Burden
			\textit{Characterising the D2 statistic: word matches in biological sequences}
			\\ \texttt{https://arxiv.org/pdf/0909.1370.pdf}
			Statistical Applications in Genetics and Molecular Biology, vol 8(1), 2009, article 43

		\bibitem{image}
			Figure \ref{countmin image} taken from
			\\ \texttt{https://stackoverflow.com/questions/6811351/explaining-the-count-sketch\-algorithm}
	\end{thebibliography}{}

\end{document}